/*{*************************************************************************
				  XMBBondLine.cpp  -  description
					  -------------------
     begin                : Fri Jul 21 2006
     copyright            : (C) 2006 by ImazInatIon
     email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *************************************************************************}*/

#include "XMBBondLine.h"
#include "XMBBond.h"
#include <qmessagebox.h>

class XMBBond;

XMBBondLine::XMBBondLine( QPoint from, QPoint to, XMoleculeBuilderDoc *pDoc, XMBBond *b, bool _isDashed): QCanvasLine( pDoc->canvas ){
	isDashed = _isDashed;
	setColor( 0, 0, 255);
	setPen( QPen( QColor(color[0],color[1], color[2]), 2 , isDashed?Qt::DashLine:Qt::SolidLine) );
	bond = b;
	setPoints( int(from.x()), int(from.y()), int(to.x()), int(to.y()) );
	setZ( 1 );
	show();
}

XMBBondLine::~XMBBondLine(){

	if( bond->deleteBond(this) )
		delete bond;
}

void XMBBondLine::setFromPoint( int x, int y ){
	QPoint p = endPoint();
	setPoints( x,y, p.x(), p.y() );
}

void XMBBondLine::setToPoint( int x, int y ){
	QPoint p = startPoint();
	setPoints( p.x(), p.y(), x, y );
}

QPoint XMBBondLine::getEndPoint( void ){

	return endPoint();
}

QPoint XMBBondLine::getStartPoint( void ){

	return startPoint();
}

XMBBond *XMBBondLine::getBond(void){

	return bond;
}

void XMBBondLine::moveBy( double dx, double dy){

	bond->moveBy( dx, dy );
}

void XMBBondLine::myMoveBy( double dx, double dy ){

	QCanvasLine::moveBy( dx, dy );
}

void XMBBondLine::setColor( int r, int g, int b){
	color[0] = r;
	color[1] = g;
	color[2] = b;
}

void XMBBondLine::startHover(void){

	setPen( QPen( QColor(0,255,0), 2 , isDashed?Qt::DashLine:Qt::SolidLine) );
}

void XMBBondLine::stopHover(void){
	setPen( QPen( QColor(color[0],color[1], color[2]), 2 , isDashed?Qt::DashLine:Qt::SolidLine) );
}
