/*{**************************************************************************
  XMBBondLine.h  -  description
  -------------------
begin                : Fri Jul 21 2006
copyright            : (C) 2006 by ImazInatIon
email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *************************************************************************}*/

#ifndef XMBBONDLINE_H
#define XMBBONDLINE_H

#include <qcanvas.h>
#include  "xmoleculebuilderdoc.h"
#include "XMBBond.h"
/**
 *@author Revanth
 */

class XMBBond;
class XMoleculeBuilderDoc;

class XMBBondLine : public QCanvasLine  {
	public:
		// constructor
		XMBBondLine( QPoint, QPoint, XMoleculeBuilderDoc *pDoc, XMBBond *b, bool isDashed);

		// destructor
		~XMBBondLine();

		// get endpoints
		void setFromPoint( int x, int y ) ;
		void setToPoint( int x, int y );

		// set endpoints
		QPoint getStartPoint( void );
		QPoint getEndPoint( void );

		// get parent bond
		XMBBond *getBond(void);

		// move the bond
		void moveBy(double dx, double dy);
		void myMoveBy(double dx, double dy);

		// set colour
		void setColor( int r, int g, int b);

		// hover
		void startHover();
		void stopHover();
	private:

		// parent
		XMBBond *bond;

		// colour of the bond
		int color[3];

		// is the line dashed
		bool isDashed;
};

#endif
