/***************************************************************************
  XMBI3D.h  -  description
  -------------------
begin                : Fri Jul 21 2006
copyright            : (C) 2006 by ImazInatIon
email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *************************************************************************}*/


#ifndef I3DVIEW_H
#define I3DVIEW_H

#include <iostream>

#include <qcanvas.h>

#include <SDL/SDL.h>
#include <SDL/SDL_opengl.h>
//#include <GL/glut.h>
#include "XMBAtom.h"
#include "XMBMolecule.h"
#include "XMBBondLine.h"

class XMBI3dView {
	public:
		XMBI3dView(QCanvas* c);
		~XMBI3dView();
		
		void view(void);
		
	private:
		int pastTime;
		bool spclkeys, rotation[2];
		int bondsCount, atomsCount, totalAtomCount;
		XMBAtom** atomsArr;
		GLUquadricObj *quadratic;
		int eye[3], pos[3], defaultPos[3], defaulteye;
		float rho;
		float rotYAngle, rotXAngle;
		GLfloat ambience[4];
		GLfloat diffuse[4];
		GLfloat specular[4];
		GLfloat position[4];
		QCanvas* canvas;

		int nFlags;
		const SDL_VideoInfo *pSDLVideoInfo;
		SDL_Surface *pSDLSurface;

		int getIndex( XMBAtom* );
		void RenderMolecule( XMBMolecule* );
		void CreateLists(void);
		void init(void);
		void renderScene(void);
		bool HandleKeyboard( SDL_keysym* );
};

#endif
