/***************************************************************************
                          xmoleculebuilder.cpp  -  description
                             -------------------
    begin                : Fri Jul 21 2006
    copyright            : (C) 2006 by ImazInatIon
    email                : revanth_nr@students.iiit.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qaccel.h>
#include "xmoleculebuilder.h"
#include "icons/filesave.xpm"
#include "icons/fileopen.xpm"
#include "icons/filenew.xpm"

#define VERSION "1.1"

XMoleculeBuilderApp::XMoleculeBuilderApp()
{
	setCaption(tr("XMoleculeBuilder " VERSION));

	initDoc();
	initView();
	///////////////////////////////////////////////////////////////////
	// call inits to invoke all other construction parts
	initActions();

	//do not show menu bar
	initMenuBar();
	initToolBar();
	initStatusBar();

	initI3dView();

//	initDoc();
//	initView();

	viewToolBar->setOn(true);
	viewStatusBar->setOn(true);
	viewLibraryBar->setOn(true);
	resize( 450, 400 );
	QApplication::setGlobalMouseTracking(true);
	viewToolBar->setOn(true);
	viewStatusBar->setOn(true);
	viewLibraryBar->setOn(true);

/*	QFile f(tr(".session"));
	if( f.open(IO_ReadOnly ))
	{
		QString str;
		QTextStream s( &f );
		s >> str;
		QByteArray state(str.toAscii());
		QMainWindow.restoreState(&state);
		f.close();
	}*/
}

XMoleculeBuilderApp::~XMoleculeBuilderApp()
{
/*	QByteArray arr=saveState();
	QFile f(tr(".session"));
	if( f.open(IO_WriteOnly ))
	{
		QTextStream s( &f );
		s << tr(arr.data());
		f.close();
	}*/
}

/** initializes all QActions of the application */
void XMoleculeBuilderApp::initActions(){


	QPixmap newIcon, openIcon, saveIcon;
	newIcon = QPixmap(filenew);
	openIcon = QPixmap(fileopen);
	saveIcon = QPixmap(filesave);

	
	fileNew = new QAction(tr("New File"), newIcon, tr("&New"), QAccel::stringToKey(tr("Ctrl+N")), this);
	fileNew->setStatusTip(tr("Creates a new document"));
	fileNew->setWhatsThis(tr("New File\n\nCreates a new document"));
	connect(fileNew, SIGNAL(activated()), this, SLOT(slotFileNew()));
	
	fileOpen = new QAction(tr("Open File"), openIcon, tr("&Open..."), QAccel::stringToKey(tr("Ctrl+O")), this);
	fileOpen->setStatusTip(tr("Opens an existing document"));
	fileOpen->setWhatsThis(tr("Open File\n\nOpens an existing document"));
	connect(fileOpen, SIGNAL(activated()), this, SLOT(slotFileOpen()));

	fileSave = new QAction(tr("Save File"), saveIcon, tr("&Save"), QAccel::stringToKey(tr("Ctrl+S")), this);
	fileSave->setStatusTip(tr("Saves the actual document"));
	fileSave->setWhatsThis(tr("Save File.\n\nSaves the actual document"));
	connect(fileSave, SIGNAL(activated()), this, SLOT(slotFileSave()));

	fileSaveAs = new QAction(tr("Save File As"), tr("Save &as..."), 0, this);
	fileSaveAs->setStatusTip(tr("Saves the actual document under a new filename"));
	fileSaveAs->setWhatsThis(tr("Save As\n\nSaves the actual document under a new filename"));
	connect(fileSaveAs, SIGNAL(activated()), this, SLOT(slotFileSaveAs()));

	fileClose = new QAction(tr("Close File"), tr("&Close"), QAccel::stringToKey(tr("Ctrl+W")), this);
	fileClose->setStatusTip(tr("Closes the actual document"));
	fileClose->setWhatsThis(tr("Close File\n\nCloses the actual document"));
	connect(fileClose, SIGNAL(activated()), this, SLOT(slotFileClose()));

	filePrint = new QAction(tr("Print File"), tr("&Print"), QAccel::stringToKey(tr("Ctrl+P")), this);
	filePrint->setStatusTip(tr("Prints out the actual document"));
	filePrint->setWhatsThis(tr("Print File\n\nPrints out the actual document"));
	connect(filePrint, SIGNAL(activated()), this, SLOT(slotFilePrint()));

	fileQuit = new QAction(tr("Exit"), tr("E&xit"), QAccel::stringToKey(tr("Ctrl+Q")), this);
	fileQuit->setStatusTip(tr("Quits the application"));
	fileQuit->setWhatsThis(tr("Exit\n\nQuits the application"));
	connect(fileQuit, SIGNAL(activated()), this, SLOT(slotFileQuit()));
	
	viewToolBar = new QAction(tr("Toolbar"), tr("Tool&bar"), 0, this, 0, true);
	viewToolBar->setStatusTip(tr("Enables/disables the toolbar"));
	viewToolBar->setWhatsThis(tr("Toolbar\n\nEnables/disables the toolbar"));
	connect(viewToolBar, SIGNAL(toggled(bool)), this, SLOT(slotViewToolBar(bool)));

	viewStatusBar = new QAction(tr("Statusbar"), tr("&Statusbar"), 0, this, 0, true);
	viewStatusBar->setStatusTip(tr("Enables/disables the statusbar"));
	viewStatusBar->setWhatsThis(tr("Statusbar\n\nEnables/disables the statusbar"));
	connect(viewStatusBar, SIGNAL(toggled(bool)), this, SLOT(slotViewStatusBar(bool)));

	viewLibraryBar = new QAction(tr("MolLib"), tr("&MolLib"), 0, this, 0, true);
	viewLibraryBar->setStatusTip(tr("Enables/disables the Library Toolbar"));
	viewLibraryBar->setWhatsThis(tr("MolLib\n\nEnables/disables the Library Toolbar"));
	connect(viewLibraryBar, SIGNAL(toggled(bool)), this, SLOT(slotViewLibraryBar(bool)));

	helpAboutApp = new QAction(tr("About"), tr("&About..."), 0, this);
	helpAboutApp->setStatusTip(tr("About the application"));
	helpAboutApp->setWhatsThis(tr("About\n\nAbout the application"));
	connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));

	insertMolecule = new QAction(tr("Insert Molecule from Templates"), openIcon, tr("&Insert Template"), QAccel::stringToKey(tr("Ctrl+I")), this);
	insertMolecule->setStatusTip(tr("Insert Molecule from Templates"));
	insertMolecule->setWhatsThis(tr("Insert Molecule\n\nInsert Molecule from Templates"));
	connect(insertMolecule, SIGNAL(activated()), this, SLOT(slotInsertMolecule()));

	importMolecule = new QAction(tr("Import Molecule from File"), openIcon, tr("I&mport"), QAccel::stringToKey(tr("Ctrl+J")), this);
	importMolecule->setStatusTip(tr("Import Molecule from file"));
	importMolecule->setWhatsThis(tr("Import Molecule\n\nInsert Molecule from file"));
	connect(importMolecule, SIGNAL(activated()), this, SLOT(slotImportMolecule()));

	// XMB specific

	viewGrp = new QActionGroup( this, 0);
	viewGrp->setExclusive( TRUE );
	viewGrp->setUsesDropDown( TRUE );

	viewMode = new QAction(tr("View Mode"), QPixmap::fromMimeSource( "icons/view.xpm" ), tr("&View Mode"), QAccel::stringToKey(tr("Ctrl+V")), viewGrp, "ViewMode");
	viewMode->setStatusTip(tr("View Mode"));
	viewMode->setWhatsThis(tr("View Mode\n\nView Mode"));
	viewMode->setToggleAction(TRUE);
	connect(viewMode, SIGNAL(activated()), this, SLOT(slotSelectViewMode()));

	rotateMode = new QAction(tr("Rotate Mode"), QPixmap::fromMimeSource( "icons/rotate.xpm" ), tr("&Rotate Mode"), QAccel::stringToKey(tr("Ctrl+V")), viewGrp, "rotateMode");
	rotateMode->setStatusTip(tr("Rotate Mode"));
	rotateMode->setWhatsThis(tr("Rotate Mode\n\nRotate Mode"));
	rotateMode->setToggleAction(TRUE);
	connect(rotateMode, SIGNAL(activated()), this, SLOT(slotSelectRotateMode()));

	drawBond = new QAction(tr("Draw Bond"), QPixmap::fromMimeSource( "icons/singlebond.xpm" ), tr("&Draw Bond"), QAccel::stringToKey(tr("Ctrl+B")), viewGrp, "DrawBond");
	drawBond->setStatusTip(tr("Draw a bond"));
	drawBond->setWhatsThis(tr("Draw Bond\n\nDraw a bond"));
	drawBond->setToggleAction(TRUE);
	connect(drawBond, SIGNAL(activated()), this, SLOT(slotSelectAddBond()));

	drawDashedBond = new QAction(tr("Add Dashed Bond"), QPixmap::fromMimeSource( "icons/dashedbond.xpm" ), tr("&Add Dashed Bond"), QAccel::stringToKey(tr("Ctrl+D")), viewGrp, "DrawDashedBond");
	drawDashedBond->setStatusTip(tr("Add Dashed Bond"));
	drawDashedBond->setWhatsThis(tr("Add Dashed Bond\n\nAdd Dashed Bond"));
	drawDashedBond->setToggleAction(TRUE);
	connect(drawDashedBond, SIGNAL(activated()), this, SLOT(slotSelectAddDashedBond()));
	
	connect(view, SIGNAL(displayBondDetail(char*)), this, SLOT(slotDisplayBondDetail(char*)));

	drawStereoUp = new QAction(tr("Add Stereo Bond"), QPixmap::fromMimeSource( "icons/stereoup.xpm" ), tr("&Add Stereo Bond"), QAccel::stringToKey(tr("Ctrl+D")), viewGrp, "DrawStereoUp");
	drawStereoUp->setStatusTip(tr("Add Stereo Bond"));
	drawStereoUp->setWhatsThis(tr("Add Stereo Bond\n\nAdd Stereo Bond"));
	drawStereoUp->setToggleAction(TRUE);
	connect(drawStereoUp, SIGNAL(activated()), this, SLOT(slotSelectAddStereoUp()));

	drawStereoDown = new QAction(tr("Add Stereo Bond"), QPixmap::fromMimeSource( "icons/stereodown.xpm" ), tr("&Add Stereo Bond"), QAccel::stringToKey(tr("Ctrl+D")), viewGrp, "DrawStereoDown");
	drawStereoDown->setStatusTip(tr("Add Stereo Bond"));
	drawStereoDown->setWhatsThis(tr("Add Stereo Bond\n\nAdd Stereo Bond"));
	drawStereoDown->setToggleAction(TRUE);
	connect(drawStereoDown, SIGNAL(activated()), this, SLOT(slotSelectAddStereoDown()));

	zigzagStructure = new QAction(tr("Zig Zag Structure"), QPixmap::fromMimeSource( "icons/zigzag.xpm" ), tr("&Zig Zag Structure"), QAccel::stringToKey(tr("Ctrl+G")), viewGrp, "Zig Zag Structure");
	zigzagStructure->setStatusTip(tr("Zig Zag Structure"));
	zigzagStructure->setWhatsThis(tr("Zig Zag Structure\n\nZig Zag Structure"));
	zigzagStructure->setToggleAction(TRUE);
	connect(zigzagStructure, SIGNAL(activated()), this, SLOT(slotZigzagStructure()));
	
	connect(view, SIGNAL(zigzagAtomValue(int)), this, SLOT(slotZigzagAtomCount(int)));

	deleteItem = new QAction(tr("Delete Item"), QPixmap::fromMimeSource( "icons/delete.xpm" ), tr("&Delete Item"), QAccel::stringToKey(tr("Ctrl+X")), viewGrp, "DeleteItem");
	deleteItem->setStatusTip(tr("Delete Item"));
	deleteItem->setWhatsThis(tr("Delete Item\n\nDelete Item"));
	deleteItem->setToggleAction(TRUE);
	connect(deleteItem, SIGNAL(activated()), this, SLOT(slotSelectDeleteItem()));

	fixedLength = new QAction(tr("Fixed Length"), QPixmap::fromMimeSource( "icons/fixedlength.xpm" ), tr("&Fixed Length"), QAccel::stringToKey(tr("Ctrl+X")), this, "Fixed Length");
	fixedLength->setStatusTip(tr("Fixed Length"));
	fixedLength->setWhatsThis(tr("Fixed Length\n\nFixed Length"));
	fixedLength->setToggleAction(TRUE);
	connect(fixedLength, SIGNAL(activated()), this, SLOT(slotSelectFixedLength()));

	fixedAngle = new QAction(tr("Fixed Angle"), QPixmap::fromMimeSource( "icons/fixedangle.xpm" ), tr("&Fixed Angle"), QAccel::stringToKey(tr("Ctrl+X")), this, "Fixed Angle");
	fixedAngle->setStatusTip(tr("Fixed Angle"));
	fixedAngle->setWhatsThis(tr("Fixed Angle\n\nFixed Angle"));
	fixedAngle->setToggleAction(TRUE);
	connect(fixedAngle, SIGNAL(activated()), this, SLOT(slotSelectFixedAngle()));

	//I3D Model View
	I3DView = new QAction(tr("I3D View"), QPixmap::fromMimeSource( "icons/i3d.xpm" ), tr("&I3DView"), QAccel::stringToKey(tr("Ctrl+F")), viewGrp, "I3D View");
	I3DView->setStatusTip(tr("I3D View"));
	I3DView->setWhatsThis(tr("I3D View\n\n3D View of Models"));
	connect(I3DView, SIGNAL(activated()), this, SLOT(slotSelectI3DView()));
	
	// molecule library molecules
	xmtBenzene = new QAction(tr("Benzene"), QPixmap::fromMimeSource( "lib/benzene.xpm" ), tr("&Benzene"), QAccel::stringToKey(tr("Ctrl+B")), this, "Benzene");
	xmtBenzene->setStatusTip(tr("Benzene"));
	xmtBenzene->setWhatsThis(tr("Benzene\n\nBenzene"));
	connect(xmtBenzene, SIGNAL(activated()), this, SLOT(slotAddBenzene()));

	xmtCubane = new QAction(tr("Cubane"), QPixmap::fromMimeSource( "lib/cubane.xpm" ), tr("&Cubane"), QAccel::stringToKey(tr("Ctrl+B")), this, "Cubane");
	xmtCubane->setStatusTip(tr("Cubane"));
	xmtCubane->setWhatsThis(tr("Cubane\n\nCubane"));
	connect(xmtCubane, SIGNAL(activated()), this, SLOT(slotAddCubane()));
	
	xmtHexane = new QAction(tr("Hexane"), QPixmap::fromMimeSource( "lib/hexane.xpm" ), tr("&Hexane"), QAccel::stringToKey(tr("Ctrl+B")), this, "Hexane");
	xmtHexane->setStatusTip(tr("Hexane"));
	xmtHexane->setWhatsThis(tr("Hexane\n\nHexane"));
	connect(xmtHexane, SIGNAL(activated()), this, SLOT(slotAddHexane()));

	xmtMegaphon = new QAction(tr("Megaphon"), QPixmap::fromMimeSource( "lib/megaphon.xpm" ), tr("&Megaphon"), QAccel::stringToKey(tr("Ctrl+B")), this, "Megaphon");
	xmtMegaphon->setStatusTip(tr("Megaphon"));
	xmtMegaphon->setWhatsThis(tr("Megaphon\n\nMegaphon"));
	connect(xmtMegaphon, SIGNAL(activated()), this, SLOT(slotAddMegaphon()));

	xmtProp = new QAction(tr("Prop"), QPixmap::fromMimeSource( "lib/prop.xpm" ), tr("&Prop"), QAccel::stringToKey(tr("Ctrl+B")), this, "Prop");
	xmtProp->setStatusTip(tr("Prop"));
	xmtProp->setWhatsThis(tr("Prop\n\nProp"));
	connect(xmtProp, SIGNAL(activated()), this, SLOT(slotAddProp()));

	xmtWater = new QAction(tr("Water"), QPixmap::fromMimeSource( "lib/water.xpm" ), tr("&Water"), QAccel::stringToKey(tr("Ctrl+B")), this, "Water");
	xmtWater->setStatusTip(tr("Water"));
	xmtWater->setWhatsThis(tr("Water\n\nWater"));
	connect(xmtWater, SIGNAL(activated()), this, SLOT(slotAddWater()));
	
/*	mlBenzene = new QAction(tr("Benzene"), QPixmap::fromMimeSource( "lib/benzene.xpm" ), tr("&Benzene"), QAccel::stringToKey(tr("Ctrl+B")), this, "Benzene");
	mlBenzene->setStatusTip(tr("Benzene"));
	mlBenzene->setWhatsThis(tr("Benzene\n\nBenzene"));
	connect(mlBenzene, SIGNAL(activated()), this, SLOT(slotAddBenzene()));*/
}

void XMoleculeBuilderApp::initMenuBar()
{
	///////////////////////////////////////////////////////////////////
	// MENUBAR

	///////////////////////////////////////////////////////////////////
	// menuBar entry pFileMenu
	pFileMenu=new QPopupMenu();
	fileNew->addTo(pFileMenu);
	fileOpen->addTo(pFileMenu);
	fileClose->addTo(pFileMenu);
	pFileMenu->insertSeparator();
	fileSave->addTo(pFileMenu);
	fileSaveAs->addTo(pFileMenu);
	pFileMenu->insertSeparator();
	filePrint->addTo(pFileMenu);
	pFileMenu->insertSeparator();
	fileQuit->addTo(pFileMenu);

	///////////////////////////////////////////////////////////////////
	// menuBar entry pViewMenu
	pViewMenu=new QPopupMenu();
	pViewMenu->setCheckable(true);
	viewToolBar->addTo(pViewMenu);
	viewStatusBar->addTo(pViewMenu);
	viewLibraryBar->addTo(pViewMenu);
	
	///////////////////////////////////////////////////////////////////
	// menuBar entry pInsertMenu
	pInsertMenu=new QPopupMenu();
	insertMolecule->addTo(pInsertMenu);
	importMolecule->addTo(pInsertMenu);
	
	///////////////////////////////////////////////////////////////////
	// EDIT YOUR APPLICATION SPECIFIC MENUENTRIES HERE

	///////////////////////////////////////////////////////////////////
	// menuBar entry pHelpMenu
	pHelpMenu=new QPopupMenu();
	helpAboutApp->addTo(pHelpMenu);

	///////////////////////////////////////////////////////////////////
	// MENUBAR CONFIGURATION
	menuBar()->insertItem(tr("&File"), pFileMenu);
	menuBar()->insertItem(tr("&View"), pViewMenu);
	menuBar()->insertItem(tr("&Insert"), pInsertMenu);
	menuBar()->insertSeparator();
	menuBar()->insertItem(tr("&Help"), pHelpMenu);

}

void XMoleculeBuilderApp::initToolBar()
{
	///////////////////////////////////////////////////////////////////
	// TOOLBAR
	fileToolbar = new QToolBar(this, "file operations");
	fileNew->addTo(fileToolbar);
	fileToolbar->addSeparator();
	fileOpen->addTo(fileToolbar);
	fileSave->addTo(fileToolbar);
	fileToolbar->addSeparator();
	QWhatsThis::whatsThisButton(fileToolbar);
	
	
	// XMB specific
	drawToolBar = new QToolBar( this, "draw operations");
	viewMode->addTo(drawToolBar);
	rotateMode->addTo(drawToolBar);
	drawToolBar->addSeparator();
	drawBond->addTo(drawToolBar);
	drawDashedBond->addTo(drawToolBar);
	drawStereoUp->addTo(drawToolBar);
	drawStereoDown->addTo(drawToolBar);
	zigzagStructure->addTo(drawToolBar);
	drawToolBar->addSeparator();
	deleteItem->addTo(drawToolBar);
	drawToolBar->addSeparator();
	fixedLength->addTo(drawToolBar);
	fixedAngle->addTo(drawToolBar);
	drawToolBar->addSeparator();
	
	//3D Model View
	drawToolBar = new QToolBar( this, "I3D Model View");
	I3DView->addTo(drawToolBar);
	drawToolBar->addSeparator();

	//molecule library
	libraryToolBar = new QToolBar( this, "Molecule library");
//	QPtrList<QDockWindow>::iterator it;
	QPtrList<QDockWindow> l = dockWindows();
	QMainWindow::moveDockWindow(l.take(3),DockLeft);
	xmtBenzene->addTo(libraryToolBar);
	xmtHexane->addTo(libraryToolBar);
	xmtCubane->addTo(libraryToolBar);
	xmtProp->addTo(libraryToolBar);
	xmtWater->addTo(libraryToolBar);
	xmtMegaphon->addTo(libraryToolBar);
}

void XMoleculeBuilderApp::initStatusBar()
{
	///////////////////////////////////////////////////////////////////
	//STATUSBAR
	statusBar()->message(tr("Ready."), 4000);
}

void XMoleculeBuilderApp::initDoc()
{
	doc=new XMoleculeBuilderDoc();
}

void XMoleculeBuilderApp::initView()
{
	///////////////////////////////////////////////////////////////
	// set the main widget here
	doc->newDoc();
	view=new XMoleculeBuilderView(this, doc);
	setCentralWidget(view);
}

void XMoleculeBuilderApp::initI3dView()
{
	///////////////////////////////////////////////////////////////////
	//3D Viewer
	i3dviewer=new XMBI3dView((QCanvas*)(doc->canvas));
}
	
bool XMoleculeBuilderApp::queryExit()
{
	int exit=QMessageBox::information(this, tr("Quit !"),
			tr("Do your really want to quit?"),
			QMessageBox::Ok, QMessageBox::Cancel);

	if (exit==1)
	{
		
	}
	else
	{
		
	};

	return (exit==1);
}

/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////

void XMoleculeBuilderApp::slotFileNew()
{
	statusBar()->message(tr("Creating file"));
	
	QCanvasItemList::iterator it;
	QCanvasItemList l = doc->canvas->allItems();

	for (it=l.begin(); it!=l.end();)
		if( (*it)->rtti() == 6 )
		{
			delete (*it);
			l=doc->canvas->allItems();
			it = l.begin();
		}
		else
			++it;
}

void XMoleculeBuilderApp::slotFileOpen()
{
	statusBar()->message(tr("Opening file..."),5000);

	QString fileName = QFileDialog::getOpenFileName("data/","XMolBuild (*.xmb)",this,"Open file dialog","Choose a File");
	doc->docName = fileName;
	
	if (!fileName.isEmpty())
	{
		QCanvasItemList::iterator it;
		QCanvasItemList l = doc->canvas->allItems();

		for (it=l.begin(); it!=l.end();)
			if( (*it)->rtti() == 6 )
			{
				delete (*it);
				l=doc->canvas->allItems();
				it = l.begin();
			}
			else
				++it;

		doc->load(fileName);
		setCaption(fileName);
		QString message=tr("Loaded document: ")+fileName;
		statusBar()->message(message, 4000);
	}
	else
	{
		statusBar()->message(tr("Opening aborted"), 4000);
	}
}


void XMoleculeBuilderApp::slotFileSave()
{
	statusBar()->message(tr("Saving file..."),5000);
	if( doc->docName == tr("noname.xmb") )
	{
		QString fn = QFileDialog::getSaveFileName("/home","XMolBuild(*.xmb)",this,"Save File dialog","Choose a Filename to save under");        doc->docName=fn+".xmb";
	}
	doc->save();
	statusBar()->message(tr("Saving Done !"),4000);
}

void XMoleculeBuilderApp::slotFileSaveAs()
{
	statusBar()->message(tr("Saving file under new filename..."),5000);
	QString fn = QFileDialog::getSaveFileName("/home","XMolBuild(*.xmb)",this,"Save File dialog","Choose a Filename to save under");
	fn.append(tr(".xmb"));
	statusBar()->message(tr("Saving As.."),5000);
	if (!fn.isEmpty())
	{
		doc->saveAs(fn);
		statusBar()->message(tr("Saving Done !"),4000);
	}
	else
	{
		statusBar()->message(tr("Saving aborted"), 4000);
	}
}

void XMoleculeBuilderApp::slotFileClose()
{
	statusBar()->message(tr("Closing file..."),5000);
	QMessageBox mb( tr("Close !"), 
			tr("Closing the File..\n"
			"Do your want to save ur changes to File?"),
			QMessageBox::Information,
			QMessageBox::Yes | QMessageBox::Default,
			QMessageBox::No,
			QMessageBox::Cancel | QMessageBox::Escape );
	mb.setButtonText( QMessageBox::Yes, "Save" );
	mb.setButtonText( QMessageBox::No, "Discard" );
	QCanvasItemList::iterator it;
	QCanvasItemList l = doc->canvas->allItems();
	switch( mb.exec() ) {
		case QMessageBox::Yes:
			// save and exit
			slotFileSave();
			for (it=l.begin(); it!=l.end();)
				if( (*it)->rtti() == 6 )
				{
					delete (*it);
					l=doc->canvas->allItems();
					it = l.begin();
				}
				else
					++it;
			statusBar()->message(tr("Done !"),4000);
			break;
		case QMessageBox::No:
			// close without saving
			for (it=l.begin(); it!=l.end();)
				if( (*it)->rtti() == 6 )
				{
					delete (*it);
					l=doc->canvas->allItems();
					it = l.begin();
				}
				else
					++it;
			statusBar()->message(tr("Done !"),4000);
			break;
		case QMessageBox::Cancel:
			// don’t save and don’t close
			statusBar()->message(tr("Close Aborted..."),4000);
			break;
	}
}

void XMoleculeBuilderApp::slotFilePrint()
{
	statusBar()->message(tr("Printing..."));
	QPrinter printer;
	if (printer.setup(this))
	{
		QPainter painter;
		painter.begin(&printer);

		///////////////////////////////////////////////////////////////////
		// TODO: Define printing by using the QPainter methods here

		painter.end();
	};

	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotFileQuit()
{
	statusBar()->message(tr("Exiting application..."));
	///////////////////////////////////////////////////////////////////
	// exits the Application
	if(doc->isModified())
	{
		if(queryExit())
		{
			qApp->quit();
		}
		else
		{
			
		};
	}
	else
	{
		qApp->quit();
	};

	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotViewToolBar(bool toggle)
{
	statusBar()->message(tr("Toggle toolbar..."));
	///////////////////////////////////////////////////////////////////
	// turn Toolbar on or off

	if (toggle== false)
	{
		fileToolbar->hide();
	}
	else
	{
		fileToolbar->show();
	};

	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotViewStatusBar(bool toggle)
{
	statusBar()->message(tr("Toggle statusbar..."));
	///////////////////////////////////////////////////////////////////
	//turn Statusbar on or off

	if (toggle == false)
	{
		statusBar()->hide();
	}
	else
	{
		statusBar()->show();
	}

	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotViewLibraryBar(bool toggle)
{
	statusBar()->message(tr("Toggle statusbar..."));
	///////////////////////////////////////////////////////////////////
	//turn Statusbar on or off

	if (toggle == false)
	{
		statusBar()->hide();
	}
	else
	{
		statusBar()->show();
	}

	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotHelpAbout()
{
	QMessageBox::about(this,tr("About..."),
			tr("XMoleculeBuilder\nVersion " VERSION "\n(c) 2006 by ImazInatIon") );
}

void XMoleculeBuilderApp::slotSelectViewMode(void )
{
	if( view )
	{
		view->canvasState = XMBVS_view;
	}
}

void XMoleculeBuilderApp::slotSelectRotateMode(void )
{
	if( view )
	{
		view->canvasState = XMBVS_rotate;
	}
}

void XMoleculeBuilderApp::slotSelectAddBond(void )
{
	if( view )
	{
		view->canvasState = XMBVS_drawSimpleBond;
	}
}

void XMoleculeBuilderApp::slotSelectAddStereoUp(void )
{
	if( view )
	{
		view->canvasState = XMBVS_drawStereoUp;
	}
}

void XMoleculeBuilderApp::slotSelectAddStereoDown(void )
{
	if( view )
	{
		view->canvasState = XMBVS_drawStereoDown;
	}
}

void XMoleculeBuilderApp::slotSelectAddDashedBond(void )
{
	if( view )
	{
		view->canvasState = XMBVS_drawDashedBond;
	}
}

void XMoleculeBuilderApp::slotDisplayBondDetail(char* details)
{
	if(view->canvasState == XMBVS_drawSimpleBond || view->canvasState == XMBVS_drawDashedBond || view->canvasState == XMBVS_drawStereoUp || view->canvasState == XMBVS_drawStereoDown)
	{
		statusBar()->message(tr(details),15000);
	}
}

void XMoleculeBuilderApp::slotZigzagStructure(void)
{
	if( view )
	{
		view->canvasState = XMBVS_zigzag;
	}
}

void XMoleculeBuilderApp::slotZigzagAtomCount(int atomCount)
{
	if(view->canvasState == XMBVS_zigzag )
	{
		char count[10];
		sprintf(count,"%d Atoms",atomCount);
		statusBar()->message(tr(count),15000);
	}
}

void XMoleculeBuilderApp::slotSelectDeleteItem(void )
{
	if( view )
	{
		view->canvasState = XMBVS_deleteItem;
	}
}

void XMoleculeBuilderApp::slotInsertMolecule(void)
{
	statusBar()->message(tr("Insert Molecule.."),15000);

	if( view )
	{
		QString fileName = QFileDialog::getOpenFileName("lib/","XMolTemplate (*.xmt)",this,"Insert Moleculwe dialog","Choose a Molecule" );
		if (!fileName.isEmpty())
			doc->load(fileName,1);
	}
	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotImportMolecule(void)
{
	statusBar()->message(tr("Opening file..."));

	if( view )
	{
		QString fileName = QFileDialog::getOpenFileName("data/","XMolBuild (*.xmb)",this,"Import Moleculwe dialog","Choose a Molecule" );
		if (!fileName.isEmpty())
			doc->load(fileName,0);
	}
	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotSelectFixedLength(void)
{
	if( view )
	{
		view->fixedLengthFlag = 1 - view->fixedLengthFlag;
	}
}

void XMoleculeBuilderApp::slotSelectFixedAngle(void)
{
	if( view )
	{
		view->fixedAngleFlag = 1 - view->fixedAngleFlag;
	}
}

void XMoleculeBuilderApp::slotSelectI3DView(void)
{
	statusBar()->message(tr("Opening I3D View"));
	if( view )
	{
		i3dviewer->view();
	}
	statusBar()->message(tr("Ready."));
}

void XMoleculeBuilderApp::slotAddBenzene()
{
	statusBar()->message(tr("Loading Benzene.."),4000);
	if( view )
	{
		doc->load("lib/benzene.xmt",1);
		view->canvasState = XMBVS_view;
	}
	statusBar()->message(tr("Benzene Loaded !"),2000);
}

void XMoleculeBuilderApp::slotAddCubane()
{
	statusBar()->message(tr("Loading Cubane.."),4000);
	if( view )
	{
		doc->load("lib/cubane.xmt",1);
		view->canvasState = XMBVS_view;
	}
	statusBar()->message(tr("Cubane Loaded !"),2000);
}

void XMoleculeBuilderApp::slotAddHexane()
{
	statusBar()->message(tr("Loading Hexane.."),4000);
	if( view )
	{
		doc->load("lib/hexane.xmt",1);
		view->canvasState = XMBVS_view;
	}
	statusBar()->message(tr("Hexane Loaded !"),2000);
}

void XMoleculeBuilderApp::slotAddMegaphon()
{
	statusBar()->message(tr("Loading Megaphon.."),4000);
	if( view )
	{
		doc->load("lib/megaphon.xmt",1);
		view->canvasState = XMBVS_view;
	}
	statusBar()->message(tr("Megaphon Loaded !"),2000);
}

void XMoleculeBuilderApp::slotAddProp()
{
	statusBar()->message(tr("Loading Prop.."),4000);
	if( view )
	{
		doc->load("lib/prop.xmt",1);
		view->canvasState = XMBVS_view;
	}
	statusBar()->message(tr("Prop Loaded !"),2000);
}

void XMoleculeBuilderApp::slotAddWater()
{
	statusBar()->message(tr("Loading Water.."),4000);
	if( view )
	{
		doc->load("lib/water.xmt",1);
		view->canvasState = XMBVS_view;
	}
	statusBar()->message(tr("Water Loaded !"),2000);
}
